--- setroubleshoot.tip.ca.po.ORIG	2009-04-02 11:58:39.000000000 +0200
+++ setroubleshoot.tip.ca.po	2009-04-03 00:07:23.000000000 +0200
@@ -23,91 +23,88 @@
 "Project-Id-Version: setroubleshoot\n"
 "Report-Msgid-Bugs-To: \n"
 "POT-Creation-Date: 2009-03-19 09:22+0000\n"
-"PO-Revision-Date: 2006-09-07 11:19+0200\n"
-"Last-Translator: Xavier Conde Rueda <xavi.conde@gmail.com>\n"
+"PO-Revision-Date: 2009-04-02 12:02+0100\n"
+"Last-Translator: Oscar Osta Pueyo <oostap@gmail.com>\n"
 "Language-Team: Catalan <fedora@softcatala.net>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=utf-8\n"
 "Content-Transfer-Encoding: 8bit\n"
 
 #: ../setroubleshoot.desktop.in.h:1
-#, fuzzy
 msgid "SELinux Troubleshooter"
-msgstr "Navegador setroubleshoot"
+msgstr "Detector d'errors SELinux"
 
 #: ../setroubleshoot.desktop.in.h:2
 msgid "Troubleshoot SELinux access denials"
-msgstr ""
+msgstr "Detector d'errors d'accesos denegats SELinux"
 
 #: ../src/browser.py:61
 msgid "Quiet"
-msgstr ""
+msgstr "Silenciar"
 
 #: ../src/browser.py:62
 msgid "Date"
-msgstr ""
+msgstr "Data"
 
 #: ../src/browser.py:63 ../src/signature.py:419 ../src/signature.py:481
 msgid "Host"
-msgstr ""
+msgstr "Ordinador"
 
 #: ../src/browser.py:64
 msgid "Count"
-msgstr ""
+msgstr "Comptador"
 
 #: ../src/browser.py:65
 msgid "Category"
-msgstr ""
+msgstr "Categoria"
 
 #. Note: The following string items returned by a plugin
 #. already have had their template substitutions HTML escaped
 #. when the plugin generated it's report
 #: ../src/browser.py:66 ../src/signature.py:388 ../src/signature.py:463
-#, fuzzy
 msgid "Summary"
-msgstr "Resum:"
+msgstr "Resum"
 
 #: ../src/browser.py:714
 msgid "Scan Log File"
-msgstr ""
+msgstr "Escaneja el fitxer de registres"
 
 #: ../src/browser.py:1307 ../src/browser.py:1631
 msgid "setroubleshoot browser"
-msgstr "Navegador setroubleshoot"
+msgstr "Navegador detector d'errors"
 
 #: ../src/browser.py:1310
-#, fuzzy
 msgid "SETroubleshoot Browser"
-msgstr "Navegador setroubleshoot"
+msgstr "Navegador detector d'errors"
 
 #. File Menu
 #: ../src/browser.py:1422
 msgid "_File"
-msgstr ""
+msgstr "_Fitxer"
 
 #. View Menu
 #: ../src/browser.py:1426
 msgid "_View"
-msgstr ""
+msgstr "_Visualitza"
 
 #. Edit Menu
 #: ../src/browser.py:1431
 msgid "_Edit"
-msgstr ""
+msgstr "_Edita"
 
 #. Help Menu
 #: ../src/browser.py:1435
 msgid "_Help"
-msgstr ""
+msgstr "A_juda"
 
 #. Column Visibility Menu
 #: ../src/browser.py:1440
 msgid "_Column Visibility"
-msgstr ""
+msgstr "_Columnes de la llista"
 
 #: ../src/browser.py:1443
 msgid "Connect To..."
-msgstr ""
+msgstr "Connecta ..."
 
 #: ../src/browser.py:1443
 msgid "Connect to setroubleshoot server, browse alert results"
@@ -115,7 +112,7 @@
 
 #: ../src/browser.py:1447
 msgid "Scan Logfile..."
-msgstr ""
+msgstr "Escaneja el fitxer de registres..."
 
 #: ../src/browser.py:1447
 msgid "Scan a log file, browse alert results"
@@ -123,7 +120,7 @@
 
 #: ../src/browser.py:1451
 msgid "Save _As..."
-msgstr ""
+msgstr "_Anomena i desa..."
 
 #: ../src/browser.py:1451
 msgid "Save selected alerts in file"
@@ -131,7 +128,7 @@
 
 #: ../src/browser.py:1455
 msgid "Print..."
-msgstr ""
+msgstr "Imprimeix..."
 
 #: ../src/browser.py:1455
 msgid "Print selected alerts"
@@ -147,15 +144,15 @@
 
 #: ../src/browser.py:1464
 msgid "_Close"
-msgstr ""
+msgstr "_Tanca"
 
 #: ../src/browser.py:1464
 msgid "Close the window"
-msgstr ""
+msgstr "Tanca la finestra"
 
 #: ../src/browser.py:1467
 msgid "_Quit"
-msgstr ""
+msgstr "_Surt"
 
 #: ../src/browser.py:1467
 msgid "Exit the window"
@@ -163,11 +160,11 @@
 
 #: ../src/browser.py:1471
 msgid "Select _All"
-msgstr ""
+msgstr "Selecciona-ho t_ot"
 
 #: ../src/browser.py:1471
 msgid "Select all alerts"
-msgstr ""
+msgstr "Selecciona totes les alertes"
 
 #: ../src/browser.py:1475
 msgid "Select _None"
@@ -179,15 +176,15 @@
 
 #: ../src/browser.py:1479
 msgid "Copy"
-msgstr ""
+msgstr "_Copia"
 
 #: ../src/browser.py:1479
 msgid "Copy selected text in detail pane"
-msgstr ""
+msgstr "_Copia"
 
 #: ../src/browser.py:1483
 msgid "Copy Alert"
-msgstr ""
+msgstr "Copia la alerta"
 
 #: ../src/browser.py:1483
 msgid "Copy selected alerts in entirety to clipboard"
@@ -203,7 +200,7 @@
 
 #: ../src/browser.py:1491
 msgid "_Undelete"
-msgstr ""
+msgstr "_Desfés"
 
 #: ../src/browser.py:1491
 msgid "Clear deletion flag"
@@ -228,19 +225,19 @@
 #. --- Interaction Dialogs ---
 #: ../src/browser.py:1503 ../src/gui_utils.py:79
 msgid "Help"
-msgstr ""
+msgstr "Ajuda"
 
 #: ../src/browser.py:1503
 msgid "Show help information"
-msgstr ""
+msgstr "Mostra informació d'ajuda"
 
 #: ../src/browser.py:1507
 msgid "About"
-msgstr ""
+msgstr "_Quant a"
 
 #: ../src/browser.py:1512
 msgid "View Audit Alerts"
-msgstr ""
+msgstr "Visualitza alertes d'auditoria"
 
 #: ../src/browser.py:1512
 msgid "View alerts from audit system"
@@ -272,7 +269,7 @@
 
 #: ../src/browser.py:1533
 msgid "Show Toolbar"
-msgstr ""
+msgstr "Mostra barra d'eines"
 
 #: ../src/browser.py:1533
 msgid "Toggle the toolbar on/off"
@@ -281,12 +278,12 @@
 #: ../src/browser.py:1541
 #, python-format
 msgid "Show %s Column"
-msgstr ""
+msgstr "Mostra columna %s"
 
 #: ../src/browser.py:1541
 #, python-format
 msgid "Show/Hide %s Column"
-msgstr ""
+msgstr "Mostra/Oculta columna %s"
 
 #: ../src/browser.py:1881
 msgid "None"
@@ -317,12 +314,12 @@
 #: ../src/browser.py:2048
 #, python-format
 msgid "%d minutes %.1f seconds"
-msgstr ""
+msgstr "%d minuts %.1f segons"
 
 #: ../src/browser.py:2050
 #, python-format
 msgid "%.0f seconds"
-msgstr ""
+msgstr "%.0f segons"
 
 #: ../src/browser.py:2052
 #, python-format
@@ -331,7 +328,7 @@
 
 #: ../src/browser.py:2076
 msgid "Copyright 2006-2008 Red Hat, Inc."
-msgstr ""
+msgstr "Copyright 2006-2008 Red Hat, Inc."
 
 #: ../src/browser.py:2077
 msgid "A user friendly tool to diagnose and monitor SELinux AVC denials"
@@ -339,7 +336,7 @@
 
 #: ../src/browser.py:2092
 msgid "Save.."
-msgstr ""
+msgstr "_Desa"
 
 #: ../src/browser.py:2341 ../src/browser.py:2381
 msgid "connected"
@@ -385,14 +382,12 @@
 msgstr ""
 
 #: ../src/browser.py:2426
-#, fuzzy
 msgid "Local Server"
-msgstr "Servidor web"
+msgstr "Servidor local"
 
 #: ../src/browser.py:2430
-#, fuzzy
 msgid "Remote Server"
-msgstr "Servidor web"
+msgstr "Servidor remot"
 
 #: ../src/email_dialog.py:47
 #, fuzzy
@@ -401,7 +396,7 @@
 
 #: ../src/email_dialog.py:74
 msgid "Add"
-msgstr ""
+msgstr "Afegir"
 
 #: ../src/email_dialog.py:114
 msgid ""
@@ -468,9 +463,8 @@
 msgstr ""
 
 #: ../src/errcode.py:78
-#, fuzzy
 msgid "value unknown"
-msgstr "Desconegut"
+msgstr "Valor desconegut"
 
 #: ../src/errcode.py:79
 msgid "cannot open file"
@@ -586,7 +580,7 @@
 
 #: ../src/run_cmd.py:500
 msgid "Done: "
-msgstr ""
+msgstr "Fet: "
 
 #: ../src/server.py:203
 #, python-format
@@ -604,7 +598,7 @@
 
 #: ../src/server.py:471
 msgid "AVC"
-msgstr ""
+msgstr "AVC"
 
 #: ../src/server.py:530
 msgid "Audit Listener"
@@ -617,7 +611,7 @@
 #: ../src/signature.py:71
 #, fuzzy
 msgid "Ignore Always"
-msgstr "Ignora durant 1 dia"
+msgstr "Ignora sempre"
 
 #: ../src/signature.py:72
 msgid "Ignore After First Alert"
@@ -630,9 +624,8 @@
 msgstr ""
 
 #: ../src/signature.py:391 ../src/signature.py:465
-#, fuzzy
 msgid "Detailed Description"
-msgstr "Descripció de la correcció:"
+msgstr "Descripció detallada:"
 
 #: ../src/signature.py:394 ../src/signature.py:467
 #, fuzzy