--- fedora-web.master-talk-fedoraproject.ca.po.ORIG	2009-09-21 15:58:30.000000000 +0200
+++ fedora-web.master-talk-fedoraproject.ca.po	2009-10-03 12:37:32.881768000 +0200
@@ -23,8 +23,8 @@
 "Project-Id-Version: \n"
 "Report-Msgid-Bugs-To: EMAIL@ADDRESS\n"
 "POT-Creation-Date: 2009-07-30 17:13-0400\n"
-"PO-Revision-Date: 2009-07-13 17:34+0100\n"
-"Last-Translator: Xavier Conde Rueda <xavi.conde@gmail.com>\n"
+"PO-Revision-Date: 2009-10-03 12:05+0100\n"
+"Last-Translator: Oscar Osta Pueyo <oostap@gmail.com>\n"
 "Language-Team: Catalan <fedora@softcatala.net>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
@@ -145,24 +145,25 @@
 "telèfon VOIP compatible amb SIP."
 
 #: data/content/conference.html:7
-#, fuzzy
 msgid "Conference Bridge - Fedora Talk"
-msgstr "Ús - Fedora Talk"
+msgstr "Pasarel·la per a conferències - Fedora Talk"
 
 #: data/content/conference.html:12
-#, fuzzy
 msgid "Fedora Talk Conferencing"
-msgstr "Fedora Talk"
+msgstr "Conferències Fedora Talk"
 
 #: data/content/conference.html:13
 msgid ""
 "Fedora community members are privileged with several VOIP conference rooms.  "
 "Below is a list of the available conference rooms and their numbers."
 msgstr ""
+"Els membres de la comunitat Fedora tenen el privilegi de fer servir sales de "
+"conferències VOIP. A continuació es mostra una llista de les sales de "
+"conferències disponibles i els seus números."
 
 #: data/content/conference.html:14
 msgid "Sub-Project Conference Rooms"
-msgstr ""
+msgstr "Sales de confències per sub-projectes"
 
 #: data/content/conference.html:15
 msgid ""
@@ -170,80 +171,86 @@
 "projects.  To request a bridge for your sub-project, please create a 'New "
 "Ticket' on the fedora infrastructure"
 msgstr ""
+"Les següents pasarel·les per a conferències estan reservades per els següents "
+"sub-projectes. Per demanar una pasarel·la per el teu sub-projecte, si us plau "
+"crea una 'Nova solicitud' a fedora infrastructure"
 
 #: data/content/conference.html:15
 msgid "trac instance"
-msgstr ""
+msgstr "Instància trac"
 
 #: data/content/conference.html:18
 msgid "Sub-project"
-msgstr ""
+msgstr "Sub-projecte"
 
 #: data/content/conference.html:19 data/content/conference.html:59
 msgid "Extension"
-msgstr ""
+msgstr "Extensió"
 
 #: data/content/conference.html:20 data/content/conference.html:60
 msgid "SIP Address (for soft phones)"
-msgstr ""
+msgstr "Direcció SIP (per telèfons)"
 
 #: data/content/conference.html:23
 msgid "Infrastructure"
-msgstr ""
+msgstr "Infraestructura"
 
 #: data/content/conference.html:28
 msgid "FUDCon"
-msgstr ""
+msgstr "FUDCon"
 
 #: data/content/conference.html:33
 msgid "Marketing"
-msgstr ""
+msgstr "Comercialització"
 
 #: data/content/conference.html:38
 msgid "Fedora Activity Day"
-msgstr ""
+msgstr "Dia d'activitats Fedora"
 
 #: data/content/conference.html:43
 msgid "Documentation"
-msgstr ""
+msgstr "Documentació"
 
 #: data/content/conference.html:48
 msgid "Ambassadors"
-msgstr ""
+msgstr "Ambaixadors"
 
 #: data/content/conference.html:54
 msgid "General Conference Rooms"
-msgstr ""
+msgstr "Sales de conferències general"
 
 #: data/content/conference.html:55
 msgid ""
 "The following conference bridges can be used by anyone.  If you join a "
 "bridge and it is already in use, try another bridge."
 msgstr ""
+"Les següents pasarel·les de conferències poden ser utilitzades per qualsevol "
+"persona. Si vols fer servir una pasarel·la y aquesta està en ús, prova un altre "
+"pasarel·la."
 
 #: data/content/conference.html:58
 msgid "Room Name"
-msgstr ""
+msgstr "Nom de sala"
 
 #: data/content/conference.html:63
 msgid "Conference Room 0"
-msgstr ""
+msgstr "Sala de conferència 0"
 
 #: data/content/conference.html:68
 msgid "Conference Room 1"
-msgstr ""
+msgstr "Sala de conferència 1"
 
 #: data/content/conference.html:73
 msgid "Conference Room 2"
-msgstr ""
+msgstr "Sala de conferència 2"
 
 #: data/content/conference.html:78
 msgid "Conference Room 3"
-msgstr ""
+msgstr "Sala de conferència 3"
 
 #: data/content/conference.html:83
 msgid "Conference Room 4"
-msgstr ""
+msgstr "Sala de conferència 4"
 
 #: data/content/faq.html:7
 msgid "FAQs - Fedora Talk"
@@ -400,7 +407,6 @@
 msgstr "Twinkle"
 
 #: data/content/usage.html:18
-#, fuzzy
 msgid ""
 "There is a <a href=\"http://fedorapeople.org/groups/web/fedoratalk-twinkle-"
 "screencast.ogg\">useful video tutorial</a> for configuring Twinkle with "
@@ -408,8 +414,8 @@
 "fedoraproject.org/wiki\">Fedora Project wiki</a>, possibly even by <em>you</"
 "em>."
 msgstr ""
-"Hi ha un <a href=\"http://herlo.fedorapeople.org/screencasts/fedoratalk-"
-"twinkle-screencast.ogg\">útil video tutorial</a> per configurar Twinkle amb "
+"Hi ha un <a href=\"http://fedorapeople.org/groups/web/fedoratalk-twinkle-"
+"screencast.ogg\">útil video tutorial</a> per configurar Twinkle amb "
 "Fedora Talk. Es pot afegir contingut útil a la <a href=\"http://"
 "fedoraproject.org/wiki\">wiki del projecte Fedora</a>, possiblement "
 "<em>vostre</em>."
@@ -439,15 +445,14 @@
 "banda i determinar si hi ha eco, soroll estàtic o un altre problema."
 
 #: data/templates/foot.html:9
-#, fuzzy
 msgid ""
 "&copy; 2009 Red Hat, Inc. and others.  Please send any comments or "
 "corrections to the <a href=\"mailto:webmaster@fedoraproject.org\">websites "
 "team</a>."
 msgstr ""
-"Copyright &copy; 2009 Red Hat, Inc. i altres. Tots els drets reservats. Si "
-"us plau, envieu comentaris o correccions a l'<a href=\"mailto:"
-"webmaster@fedoraproject.org\">equip dels llocs webs</a>."
+"&copy; 2009 Red Hat, Inc. i altres. Si us plau, envieu comentaris o "
+"correccions a l'<a href=\"mailto:webmaster@fedoraproject.org\">equip "
+"dels llocs webs</a>."
 
 #: data/templates/foot.html:12
 msgid ""
@@ -501,7 +506,7 @@
 
 #: data/templates/sidebar.html:17
 msgid "Conferencing"
-msgstr ""
+msgstr "Conferències"
 
 #: data/templates/sidebar.html:18
 msgid "Troubleshooting"