--- comps.HEAD.ca.po.ORIG	2009-01-21 22:53:00.000000000 +0100
+++ comps.HEAD.ca.po	2009-01-21 23:26:08.000000000 +0100
@@ -24,8 +24,8 @@
 "Project-Id-Version: comps-po\n"
 "Report-Msgid-Bugs-To: \n"
 "POT-Creation-Date: 2009-01-19 13:33+0000\n"
-"PO-Revision-Date: 2008-10-16 11:11+0100\n"
-"Last-Translator: Xavier Conde Rueda <xavi.conde@gmail.com>\n"
+"PO-Revision-Date: 2009-01-21 23:25+0100\n"
+"Last-Translator: Oscar Osta Pueyo <oostap@gmail.com>\n"
 "Language-Team: Catalan <fedora@softcatala.net>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
@@ -530,13 +530,13 @@
 #: ../comps-f7.xml.in.h:89 ../comps-f8.xml.in.h:93 ../comps-f9.xml.in.h:96
 #: ../comps-f10.xml.in.h:102 ../comps-f11.xml.in.h:107
 msgid "Lao Support"
-msgstr "Suport per al Lao"
+msgstr "Suport per al lao"
 
 # TODO
 #: ../comps-f7.xml.in.h:90 ../comps-f8.xml.in.h:94 ../comps-f9.xml.in.h:97
 #: ../comps-f10.xml.in.h:103 ../comps-f11.xml.in.h:108
 msgid "Latvian Support"
-msgstr "Latvian Support"
+msgstr "Suport per al letó"
 
 #: ../comps-f7.xml.in.h:91 ../comps-f8.xml.in.h:96 ../comps-f9.xml.in.h:99
 #: ../comps-f10.xml.in.h:105 ../comps-f11.xml.in.h:110
@@ -572,7 +572,7 @@
 #: ../comps-f7.xml.in.h:97 ../comps-f8.xml.in.h:103 ../comps-f9.xml.in.h:107
 #: ../comps-f10.xml.in.h:114 ../comps-f11.xml.in.h:120
 msgid "Malayalam Support"
-msgstr "Suport per al malayalam"
+msgstr "Suport per al Malaialam"
 
 #: ../comps-f7.xml.in.h:98 ../comps-f8.xml.in.h:104 ../comps-f9.xml.in.h:108
 #: ../comps-f10.xml.in.h:115 ../comps-f11.xml.in.h:121
@@ -869,8 +869,8 @@
 #: ../comps-f10.xml.in.h:175 ../comps-f11.xml.in.h:182
 msgid ""
 "These packages include network-based servers such as DHCP, Kerberos and NIS."
-msgstr ""
-"S'inclouen servidors de xarxa com ara el DHCP, Kerberos i NIS."
+msgstr "" 
+"Aquests paquets inclouen servidors de xarxa com ara el DHCP, Kerberos i NIS."
 
 #: ../comps-f7.xml.in.h:150 ../comps-f8.xml.in.h:158 ../comps-f9.xml.in.h:165
 #: ../comps-f10.xml.in.h:176 ../comps-f11.xml.in.h:183
@@ -1210,7 +1210,7 @@
 #: ../comps-f8.xml.in.h:100 ../comps-f9.xml.in.h:103 ../comps-f10.xml.in.h:109
 #: ../comps-f11.xml.in.h:114
 msgid "Low Saxon Support"
-msgstr "Supor per al saxó baix"
+msgstr "Suport per al saxó baix"
 
 #: ../comps-f8.xml.in.h:106 ../comps-f9.xml.in.h:110 ../comps-f10.xml.in.h:117
 #: ../comps-f11.xml.in.h:123
@@ -1234,12 +1234,11 @@
 # TODO
 #: ../comps-f9.xml.in.h:91 ../comps-f10.xml.in.h:95 ../comps-f11.xml.in.h:99
 msgid "Kashubian Support"
-msgstr "Kashubian Support"
+msgstr "Suport per al caixubi"
 
 #: ../comps-f9.xml.in.h:94 ../comps-f10.xml.in.h:99 ../comps-f11.xml.in.h:104
-#, fuzzy
 msgid "Kurdish Support"
-msgstr "Suport per al turc"
+msgstr "Suport per al kurd"
 
 #: ../comps-f9.xml.in.h:104 ../comps-f10.xml.in.h:110
 #: ../comps-f11.xml.in.h:115
@@ -1249,7 +1248,7 @@
 #: ../comps-f9.xml.in.h:115 ../comps-f10.xml.in.h:123
 #: ../comps-f11.xml.in.h:129
 msgid "Northern Sami Support"
-msgstr "Supor per al sami del nord"
+msgstr "Suport per al sami del nord"
 
 #: ../comps-f9.xml.in.h:131 ../comps-f10.xml.in.h:139
 #: ../comps-f11.xml.in.h:146
@@ -1265,7 +1264,7 @@
 #: ../comps-f9.xml.in.h:201 ../comps-f10.xml.in.h:213
 #: ../comps-f11.xml.in.h:223
 msgid "Walloon Support"
-msgstr "Walloon Support"
+msgstr "Suport per al való"
 
 #: ../comps-f10.xml.in.h:70 ../comps-f11.xml.in.h:74
 msgid "Haskell Development"
@@ -1282,7 +1281,7 @@
 # TODO
 #: ../comps-f10.xml.in.h:94 ../comps-f11.xml.in.h:98
 msgid "Kashmiri Support"
-msgstr "Kashmiri Support"
+msgstr "Suport per al caixmiri"
 
 #: ../comps-f10.xml.in.h:97 ../comps-f11.xml.in.h:102
 msgid "Konkani Support"
@@ -1290,7 +1289,7 @@
 
 #: ../comps-f10.xml.in.h:100 ../comps-f11.xml.in.h:105
 msgid "LXDE"
-msgstr ""
+msgstr "LXDE"
 
 # TODO
 #: ../comps-f10.xml.in.h:112 ../comps-f11.xml.in.h:117
@@ -1300,7 +1299,7 @@
 # TODO
 #: ../comps-f10.xml.in.h:119 ../comps-f11.xml.in.h:125
 msgid "Myanmar (Burmese) Support"
-msgstr "Suport per al myanmar (burmese)"
+msgstr "Suport per al myanmar (birmà)"
 
 # TODO
 #: ../comps-f10.xml.in.h:146 ../comps-f11.xml.in.h:153
@@ -1319,59 +1318,51 @@
 # TODO
 #: ../comps-f10.xml.in.h:207 ../comps-f11.xml.in.h:217
 msgid "Uzbek Support"
-msgstr "Uzbek Support"
+msgstr "Suport per a l'uzbek"
 
 #: ../comps-f11.xml.in.h:5
-#, fuzzy
 msgid "Amazigh Support"
-msgstr "Suport per a l'àrab"
+msgstr "Suport per al berber"
 
 #: ../comps-f11.xml.in.h:54
 msgid "Font design and packaging"
-msgstr ""
+msgstr "Disseny i empaquetat de tipus de lletra"
 
 #: ../comps-f11.xml.in.h:58
-#, fuzzy
 msgid "Frisian Support"
-msgstr "Suport per al persa"
+msgstr "Suport per al frisó"
 
 #: ../comps-f11.xml.in.h:59
-#, fuzzy
 msgid "Friulian Support"
-msgstr "Suport per al brasiler"
+msgstr "Suport per al furlà"
 
 #: ../comps-f11.xml.in.h:101
-#, fuzzy
 msgid "Kinyarwanda Support"
-msgstr "Suport per al kannada"
+msgstr "Suport per al kinyarwanda"
 
 #: ../comps-f11.xml.in.h:118
-#, fuzzy
 msgid "Malagasy Support"
-msgstr "Suport per al malai"
+msgstr "Suport per al malgaix"
 
 #: ../comps-f11.xml.in.h:132
-#, fuzzy
 msgid "Occitan Support"
-msgstr "Suport per al tibetà"
+msgstr "Suport per l'occità"
 
 #: ../comps-f11.xml.in.h:201
-#, fuzzy
 msgid ""
 "This group is a collection of tools used in the design, modification, "
 "manipulation, and packaging of fonts."
 msgstr ""
-"Aquest grup és una col·lecció d'eines i recursos per a entorns armenis."
+"Aquest grup és una col·lecció d'eines usades en el disseny, modificació, "
+"manipulació i empaquetat de tipus de lletra."
 
 #: ../comps-f11.xml.in.h:213
-#, fuzzy
 msgid "Turkmen Support"
-msgstr "Suport per al turc"
+msgstr "Suport per al turcman"
 
 #: ../comps-f11.xml.in.h:215
-#, fuzzy
 msgid "Upper Sorbian Support"
-msgstr "Suport per al serbi"
+msgstr "Suport per a l'alt sòrab"
 
 #: ../comps-el4.xml.in.h:3 ../comps-el5.xml.in.h:3
 msgid "Applications for a variety of tasks"