From 9215f5433ffe4c50cc8fc68ea81769bb9aba65d7 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Miguel=20S=C3=A1nchez=20de=20Le=C3=B3n=20Peque?= <msdeleonpeque@gmail.com>
Date: Fri, 6 Aug 2010 21:02:33 +0200
Subject: [PATCH 3/3] Added some alt attributes missing

---
 fedoraproject.org/data/content/get-fedora-all.html |    2 +-
 fedoraproject.org/data/content/get-fedora-kde.html |    4 ++--
 fedoraproject.org/data/content/get-fedora.html     |    2 +-
 fedoraproject.org/data/content/get-prerelease.html |    2 +-
 fedoraproject.org/data/templates/foot.html         |    2 +-
 5 files changed, 6 insertions(+), 6 deletions(-)

diff --git a/fedoraproject.org/data/content/get-fedora-all.html b/fedoraproject.org/data/content/get-fedora-all.html
index 8c52b3b..0db1384 100644
--- a/fedoraproject.org/data/content/get-fedora-all.html
+++ b/fedoraproject.org/data/content/get-fedora-all.html
@@ -147,7 +147,7 @@
     <div class="download-block" id="export-regulations">
             <h4>Export Regulations</h4>
             <p>By clicking on and downloading Fedora, you agree to comply with the following terms and conditions:</p>
-            <span class="read-more"><a href="#">Read full export regulations <img src="${path}/static/images/arrow_down.png" /></a></span>
+            <span class="read-more"><a href="#">Read full export regulations <img src="${path}/static/images/arrow_down.png" alt="${Markup(_('Arrow down'))}" /></a></span>
             <span class="details"><p>Fedora software and technical information is subject to the U.S. Export Administration Regulations and other U.S. and foreign law, and may not be exported or re-exported to certain countries (currently Cuba, Iran, Iraq, North Korea, Sudan, and Syria) or to persons or entities prohibited from receiving U.S. exports (including those (a) on the Bureau of Industry and Security Denied Parties List or Entity List, (b) on the Office of Foreign Assets Control list of Specially Designated Nationals and Blocked Persons, and (c) involved with missile technology or nuclear, chemical or biological weapons). You may not download Fedora software or technical information if you are located in one of these countries, or otherwise affected by these restrictions. You may not provide Fedora software or technical information to individuals or entities located in one of these countries or otherwise affected by these restrictions. You are also responsible for compliance with foreign law requirements applicable to the import and use of Fedora software and technical information.</p></span>
     </div>
 </body>
diff --git a/fedoraproject.org/data/content/get-fedora-kde.html b/fedoraproject.org/data/content/get-fedora-kde.html
index e0e2e1d..6f875c0 100644
--- a/fedoraproject.org/data/content/get-fedora-kde.html
+++ b/fedoraproject.org/data/content/get-fedora-kde.html
@@ -15,7 +15,7 @@
             <a id="advanced-banner" href="${path}/${lang}/get-fedora-all" class="even"><span>${_('Show me all download options in one page!')}</span></a>
             <span id="thereismorefedora">
                 <h4>${_("There's More Fedora!")}</h4>
-                <a href="http://spins.fedoraproject.org"><img src="/static/images/banners/spins-website.png"/></a>
+                <a href="http://spins.fedoraproject.org"><img src="/static/images/banners/spins-website.png" alt="${Markup(_('Fedora Spins'))}" /></a>
             </span>
         </div>
         <p style="overflow: auto;">
@@ -83,7 +83,7 @@
         <div class="download-block" id="export-regulations">
             <h4>Export Regulations</h4>
             <p>By clicking on and downloading Fedora, you agree to comply with the following terms and conditions:</p>
-            <span class="read-more"><a href="#">Read full export regulations <img src="${path}/static/images/arrow_down.png" /></a></span>
+            <span class="read-more"><a href="#">Read full export regulations <img src="${path}/static/images/arrow_down.png" alt="${Markup(_('Arrow down'))}" /></a></span>
             <span class="details"><p>Fedora software and technical information is subject to the U.S. Export Administration Regulations and other U.S. and foreign law, and may not be exported or re-exported to certain countries (currently Cuba, Iran, Iraq, North Korea, Sudan, and Syria) or to persons or entities prohibited from receiving U.S. exports (including those (a) on the Bureau of Industry and Security Denied Parties List or Entity List, (b) on the Office of Foreign Assets Control list of Specially Designated Nationals and Blocked Persons, and (c) involved with missile technology or nuclear, chemical or biological weapons). You may not download Fedora software or technical information if you are located in one of these countries, or otherwise affected by these restrictions. You may not provide Fedora software or technical information to individuals or entities located in one of these countries or otherwise affected by these restrictions. You are also responsible for compliance with foreign law requirements applicable to the import and use of Fedora software and technical information.</p></span>
         </div>
     </body>
diff --git a/fedoraproject.org/data/content/get-fedora.html b/fedoraproject.org/data/content/get-fedora.html
index 5132cc9..207b45f 100644
--- a/fedoraproject.org/data/content/get-fedora.html
+++ b/fedoraproject.org/data/content/get-fedora.html
@@ -71,7 +71,7 @@
         <div class="download-block" id="export-regulations">
             <h4>Export Regulations</h4>
             <p>By clicking on and downloading Fedora, you agree to comply with the following terms and conditions:</p>
-            <span class="read-more"><a href="#">Read full export regulations <img src="${path}/static/images/arrow_down.png" /></a></span>
+            <span class="read-more"><a href="#">Read full export regulations <img src="${path}/static/images/arrow_down.png" alt="${Markup(_('Arrow down'))}" /></a></span>
             <span class="details"><p>Fedora software and technical information is subject to the U.S. Export Administration Regulations and other U.S. and foreign law, and may not be exported or re-exported to certain countries (currently Cuba, Iran, Iraq, North Korea, Sudan, and Syria) or to persons or entities prohibited from receiving U.S. exports (including those (a) on the Bureau of Industry and Security Denied Parties List or Entity List, (b) on the Office of Foreign Assets Control list of Specially Designated Nationals and Blocked Persons, and (c) involved with missile technology or nuclear, chemical or biological weapons). You may not download Fedora software or technical information if you are located in one of these countries, or otherwise affected by these restrictions. You may not provide Fedora software or technical information to individuals or entities located in one of these countries or otherwise affected by these restrictions. You are also responsible for compliance with foreign law requirements applicable to the import and use of Fedora software and technical information.</p></span>
         </div>
     </body>
diff --git a/fedoraproject.org/data/content/get-prerelease.html b/fedoraproject.org/data/content/get-prerelease.html
index 8a6b07f..a4dcc35 100644
--- a/fedoraproject.org/data/content/get-prerelease.html
+++ b/fedoraproject.org/data/content/get-prerelease.html
@@ -94,7 +94,7 @@
     <div class="download-block" id="export-regulations">
             <h4>Export Regulations</h4>
             <p>By clicking on and downloading Fedora, you agree to comply with the following terms and conditions:</p>
-            <span class="read-more"><a href="#">Read full export regulations <img src="${path}/static/images/arrow_down.png" /></a></span>
+            <span class="read-more"><a href="#">Read full export regulations <img src="${path}/static/images/arrow_down.png" alt="${Markup(_('Arrow down'))}" /></a></span>
             <span class="details"><p>Fedora software and technical information is subject to the U.S. Export Administration Regulations and other U.S. and foreign law, and may not be exported or re-exported to certain countries (currently Cuba, Iran, Iraq, North Korea, Sudan, and Syria) or to persons or entities prohibited from receiving U.S. exports (including those (a) on the Bureau of Industry and Security Denied Parties List or Entity List, (b) on the Office of Foreign Assets Control list of Specially Designated Nationals and Blocked Persons, and (c) involved with missile technology or nuclear, chemical or biological weapons). You may not download Fedora software or technical information if you are located in one of these countries, or otherwise affected by these restrictions. You may not provide Fedora software or technical information to individuals or entities located in one of these countries or otherwise affected by these restrictions. You are also responsible for compliance with foreign law requirements applicable to the import and use of Fedora software and technical information.</p></span>
     </div>
   </body>
diff --git a/fedoraproject.org/data/templates/foot.html b/fedoraproject.org/data/templates/foot.html
index da71402..957f057 100644
--- a/fedoraproject.org/data/templates/foot.html
+++ b/fedoraproject.org/data/templates/foot.html
@@ -5,7 +5,7 @@
   py:strip="">
   <div id="bottom">
     <div id="footer">
-      <a href="http://www.redhat.com/"><img class="rh-logo" src="/static/images/redhat-logo.png"/></a>
+      <a href="http://www.redhat.com/"><img class="rh-logo" src="/static/images/redhat-logo.png" alt="${Markup(_('Red Hat Logo'))}" /></a>
       <ul>
         <li class="first"><a href="${path}/${lang}/sponsors">${Markup(_('Sponsors'))}</a></li>
         <li>${Markup(_('&lt;a href="http://fedoraproject.org/wiki/Legal:Main"&gt;Legal&lt;/a&gt;'))}</li>
-- 
1.7.2.1