From adccda105e560d5863da9d20b87e3d88d54c96a9 Mon Sep 17 00:00:00 2001
From: "H.J. Lu" <hjl.tools@gmail.com>
Date: Wed, 25 Mar 2015 07:22:43 -0700
Subject: [PATCH 5/7] Add run-backtrace-core-x32.sh

	* Makefile.am (TESTS): Add run-backtrace-core-x32.sh.
	(EXTRA_DIST): Likewise.
	* backtrace.x32.core.bz2 : New file.
	* backtrace.x32.exec.bz2: Likewise.
	* run-backtrace-core-x32.sh: Likewise.

Signed-off-by: H.J. Lu <hjl.tools@gmail.com>
---
 tests/Makefile.am               |   2 ++
 tests/backtrace.x32.core.bz2    | Bin 0 -> 9830 bytes
 tests/backtrace.x32.exec.bz2    | Bin 0 -> 407568 bytes
 tests/run-backtrace-core-x32.sh |  23 +++++++++++++++++++++++
 4 files changed, 25 insertions(+)
 create mode 100644 tests/backtrace.x32.core.bz2
 create mode 100644 tests/backtrace.x32.exec.bz2
 create mode 100755 tests/run-backtrace-core-x32.sh

diff --git a/tests/Makefile.am b/tests/Makefile.am
index d12a780..ee11e9c 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -107,6 +107,7 @@ TESTS = run-arextract.sh run-arsymtest.sh newfile test-nlist \
 	run-backtrace-native.sh run-backtrace-data.sh run-backtrace-dwarf.sh \
 	run-backtrace-native-biarch.sh run-backtrace-native-core.sh \
 	run-backtrace-native-core-biarch.sh run-backtrace-core-x86_64.sh \
+	run-backtrace-core-x32.sh \
 	run-backtrace-core-i386.sh run-backtrace-core-ppc.sh \
 	run-backtrace-core-s390x.sh run-backtrace-core-s390.sh \
 	run-backtrace-core-aarch64.sh \
@@ -265,6 +266,7 @@ EXTRA_DIST = run-arextract.sh run-arsymtest.sh \
 	     run-backtrace-native.sh run-backtrace-native-biarch.sh \
 	     run-backtrace-native-core.sh run-backtrace-native-core-biarch.sh \
 	     run-backtrace-core-x86_64.sh run-backtrace-core-i386.sh \
+	     run-backtrace-core-x32.sh \
 	     backtrace-subr.sh backtrace.i386.core.bz2 backtrace.i386.exec.bz2 \
 	     backtrace.x86_64.core.bz2 backtrace.x86_64.exec.bz2 \
 	     backtrace.ppc.core.bz2 backtrace.ppc.exec.bz2 \
diff --git a/tests/backtrace.x32.core.bz2 b/tests/backtrace.x32.core.bz2
new file mode 100644
index 0000000000000000000000000000000000000000..c06d70a8d81c6de3b91b061ed479918944824104
GIT binary patch
diff --git a/tests/backtrace.x32.exec.bz2 b/tests/backtrace.x32.exec.bz2
new file mode 100644
index 0000000000000000000000000000000000000000..e89401b6ce3cff20cfc7e2d65a8e4bf4a4976c62
GIT binary patch
diff --git a/tests/run-backtrace-core-x32.sh b/tests/run-backtrace-core-x32.sh
new file mode 100755
index 0000000..2ad76bc
--- /dev/null
+++ b/tests/run-backtrace-core-x32.sh
@@ -0,0 +1,23 @@
+#! /bin/bash
+# Copyright (C) H.J. Lu <hjl.tools@gmail.com>, 2015.
+# This file is part of elfutils.
+#
+# This file is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# elfutils is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+. $srcdir/backtrace-subr.sh
+
+# backtrace.x32.exec is created by
+# gcc -mx32 -static -o backtrace.x32.exec backtrace_child-backtrace-child.o -lpthread
+# backtrace.x32.core was generated by running "backtrace.x32.exec --gencore"
+check_core x32
-- 
1.9.3